--- ./config/functions	2009-05-29 14:19:30.741662868 +0100
+++ ./config/functions	2009-07-29 14:15:19.436043164 +0100
@@ -10,6 +10,8 @@
 	. /etc/default/$name
     elif [ -f $CTDB_BASE/sysconfig/$name ]; then
 	. $CTDB_BASE/sysconfig/$name
+    elif [ -f /etc/config.d/$name ]; then
+	. /etc/config.d/$name
     fi
 }
 
@@ -21,6 +23,8 @@
 
     if [ -x /sbin/startproc ]; then
         CTDB_INIT_STYLE="suse"
+    elif [ -x /bin/rc-status ]; then
+        CTDB_INIT_STYLE="gentoo"
     elif [ -x /sbin/start-stop-daemon ]; then
         CTDB_INIT_STYLE="ubuntu"
     else
@@ -400,6 +404,9 @@
 	[ -x /etc/init.d/nfslock ] && {
 		PLATFORM="rhel"
 	}
+	[ -x etc/init.d/nfs ] && {
+		PLATFORM="gentoo"
+        }
 
 	case $PLATFORM in
 	sles)
@@ -424,6 +431,16 @@
 			;;
 		esac
 		;;
+	gentoo)
+		case $1 in
+		start)
+			service nfs start
+			;;
+		stop)
+			service nfs stop > /dev/null 2>&1
+			;;
+		esac
+		;;
 	*)
 		echo "Unknown platform. NFS is not supported with ctdb"
 		exit 1
@@ -442,6 +459,9 @@
 	[ -x /etc/init.d/nfslock ] && {
 		PLATFORM="rhel"
 	}
+        [ -x etc/init.d/nfs ] && {
+                PLATFORM="gentoo"
+        }
 
 	case $PLATFORM in
 	sles)
@@ -466,6 +486,18 @@
 			;;
 		esac
 		;;
+        gentoo)
+                # for gentoo there is no service for lockmanager
+                # so we instead just shutdown/restart nfs
+                case $1 in
+                start)
+                        service nfs start
+                        ;;
+                stop)
+                        service nfs stop > /dev/null 2>&1
+                        ;;
+                esac
+                ;;
 	*)
 		echo "Unknown platform. NFS locking is not supported with ctdb"
 		exit 1
